## apt-cacher-ng 0.1.9

=== CMakeLists.txt ===
PROJECT(ACNG)
INCLUDE_DIRECTORIES(. include ${CMAKE_BINARY_DIR} )
FILE(GLOB SRCS "source/*.cc")

SET(SRCS ${SRCS} 3rd-party/md5.cc)

#FIXME: cope with CFLAGS from makefile wrapper somehow

#SET(CMAKE_CXX_FLAGS " )
SET(FLAGS_DEBUG " -O0 -g -pthread ")
SET(FLAGS_OPT " -O3 -pthread -fno-exceptions  ")
SET(FLAGS_EMBED "-static -Os -pthread -fno-exceptions ")

INCLUDE(FindBZip2)
INCLUDE(FindZLIB)

# make sure we get shared_ptr functionality
INCLUDE(CheckCXXSourceCompiles)
SET(TESTSRC "
#include <tr1/memory>
int main() { return NULL != std::tr1::shared_ptr<int>(new int(1)); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAS_TR1_SMART_POINTERS)
IF(NOT HAS_TR1_SMART_POINTERS)
   SET(HAS_TR1_SMART_POINTERS )
   ADD_DEFINITIONS(-DUSE_BOOST)
   SET(TESTSRC "
   #include <boost/smart_ptr.hpp>
   int main() { return NULL != boost::shared_ptr<int>(new int(1)); }
   ")
   CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAS_BOOST)
   IF(NOT HAS_BOOST)
      SET(HAS_BOOST )
      MESSAGE(FATAL_ERROR "No shared_ptr implementation found, install boost or modern GCC (4.x).")
   ENDIF(NOT HAS_BOOST)
ENDIF(NOT HAS_TR1_SMART_POINTERS)

SET(CMAKE_REQUIRED_LIBRARIES bz2)
SET(TESTSRC "
#include <bzlib.h>
bz_stream t; int main(){ return BZ2_bzDecompressInit(&t, 1, 0); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAS_LIBBZ2)
IF(NOT HAS_LIBBZ2)
   # MARK_AS_ADVANCED(HAS_LIBBZ2)
   SET(HAS_LIBBZ2 )
   MESSAGE(FATAL_ERROR "Unable to use libbz2 development components. Install libbz2-dev.")
ENDIF(NOT HAS_LIBBZ2)

SET(CMAKE_REQUIRED_LIBRARIES z)
SET(TESTSRC "
#include <zlib.h>
z_stream t; int main(){ return inflateInit2(&t, 42); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAS_LIBZ)
MARK_AS_ADVANCED(HAS_LIBZ)
IF(NOT HAS_LIBZ)
#   SET(HAS_LIBZ )
   MESSAGE(FATAL_ERROR "Unable to use ZLib development components. Install libz-dev.")
ENDIF(NOT HAS_LIBZ)



ADD_EXECUTABLE(apt-cacher-ng ${SRCS})
TARGET_LINK_LIBRARIES(apt-cacher-ng pthread bz2 z)

ADD_EXECUTABLE(apt-cacher-ng-debug ${SRCS})
TARGET_LINK_LIBRARIES(apt-cacher-ng-debug pthread bz2 z)

SET_TARGET_PROPERTIES(apt-cacher-ng
                        PROPERTIES COMPILE_FLAGS "  ${FLAGS_OPT}  ")
SET_TARGET_PROPERTIES(apt-cacher-ng-debug
                        PROPERTIES COMPILE_FLAGS " ${FLAGS_DEBUG} ")

=== Makefile ===

ifneq ($(DEBUG),)
CXXFLAGS += -DDEBUG 
endif

hints:
	@echo To build apt-cacher-ng and/or helper programs, use:
	@echo 'make acng        (to use CMake assisted build, normal and debug versions)'
	@echo 'make acng-static (simple GCC based build, static linking)'
	@echo 'make acng-whole  (simple GCC based build, dynamic linking, optimized)'
	@echo 'make in.acng     (wrapper client for use with inetd)'
	@echo 'make mount.acng  (http file system emulator, needs FUSE library)'

# quick and dirty, mini-build
SRCS = $(wildcard source/*.cc) 3rd-party/md5.cc
embedded: acng-small
acng-small: $(SRCS)
	$(CXX) -o $@ -combine -Os -fno-exceptions $(SRCS) $(CXXFLAGS) -I include -lpthread -lz -lbz2
	strip $@

embstatic: acng-static
acng-static: $(SRCS)
	$(CXX) -o $@ -combine -Os -fno-exceptions $(CXXFLAGS) $(SRCS) -I include -static $(LDFLAGS) -lpthread -lz -lbz2

acng-whole: $(SRCS)
	mkdir -p build
	# for some reason -combine doesn't work well with -fwhole-program, trying a workaround...
	cat $(SRCS) > build/all.cc
	$(CXX) -o $@ -fwhole-program -O2 $(CXXFLAGS) build/all.cc -Iinclude -I3rd-party -lpthread $(LDFLAGS) -lz -lbz2

lite: $(SRCS)
	$(CXX) -o $@ -combine -Os -fno-exceptions $(CXXFLAGS) $(SRCS) -I include $(LDFLAGS) -lpthread

in.acng: source/acbuf.cc client/client.cc
	mkdir -p build/cl
	$(CXX) -O2 -c -o build/cl/client.o client/client.cc -Iinclude
	$(CXX) -O2 -c -o build/cl/acbuf.o source/acbuf.cc -Iinclude
	$(CC) -o in.acng build/cl/client.o build/cl/acbuf.o -lsupc++
	strip in.acng



SRCSMOUNT=source/dlcon.cc source/header.cc fs/src/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc
mount.acng: fs/src/httpfs.cc source/acbuf.cc
	mkdir -p build/fs
	$(CXX) -Iinclude -o mount.acng `pkg-config fuse --cflags` $(SRCSMOUNT) `pkg-config fuse --libs`
#	$(CXX) -O2 -c -o build/fs/httpfs.o fs/src/httpfs.cc -Iinclude $(FUCONF)
#	$(CXX) -O2 -c -o build/fs/acbuf.o source/acbuf.cc -Iinclude
#	$(CXX) -o in.acng build/fs/httpfs.o build/fs/acbuf.o $(FULINK)
#	strip in.acng

doc: doc/src/README.but doc/src/manpage.but doc/src/mount.acng.but
	mkdir -p doc/.build doc/html doc/man
	cd doc/.build && halibut --text=README.txt --html --pdf ../src/README.but
	mv doc/.build/*.pdf doc
	mv doc/.build/README.txt doc/README
	mv doc/.build/*.html doc/html
	cd doc/.build && halibut --man ../src/manpage.but && halibut --man ../src/mount.acng.but
	mv doc/.build/*.8 doc/man

fixversion: VERSION
	mkdir -p build/tmp
	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/acfg.h > build/tmp/hh
	cmp include/acfg.h build/tmp/hh || cp build/tmp/hh include/acfg.h

VERSION=$(shell cat VERSION)
DISTNAME=apt-cacher-ng-$(VERSION)
DEBSRCNAME=apt-cacher-ng_$(shell echo $(VERSION) | sed -e "s,pre,~pre,").orig.tar.gz

ifneq ($(CXXFLAGS),)
CMAKETWEAKS += ( cd build ; cmake .. -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" ) || exit 1; 
endif

ifneq ($(LDFLAGS),)
CMAKETWEAKS += (cd build ; cmake .. -DCMAKE_EXE_LINKER_FLAGS:STRING="$(LDFLAGS)" -DCMAKE_MODULE_LINKER_FLAGS:STRING="$(LDFLAGS)" -DCMAKE_SHARED_LINKER_FLAGS:STRING="$(LDFLAGS)" ) || exit 1; 
endif

ifneq ($(PREFIX),)
CMAKETWEAKS += ( cd build ;  cmake .. -DCMAKE_INSTALL_PREFIX="$(PREFIX)") || exit 1; 
endif

ifneq ($(MANSUBDIR),)
CMAKETWEAKS += ( cd build ;  cmake .. -DMANSUBDIR="$(MANSUBDIR)" ) || exit 1; 
endif


build/Makefile:
	@echo Purging CMakeCache.txt, it caches too much... :-\(
# only effective when set PHONY
	rm -f build/CMakeCache.txt
	@-mkdir build 2>/dev/null
	cd build && cmake ..

cmakepurge:
	rm -rf install_manifest.txt progress.make CMakeFiles CMakeCache.txt cmake_install.cmake 
	rm -rf */install_manifest.txt */progress.make */CMakeFiles */CMakeCache.txt */cmake_install.cmake 
	rm -rf */*/install_manifest.txt */*/progress.make */*/CMakeFiles */*/CMakeCache.txt */*/cmake_install.cmake 
	rm */Makefile */*/Makefile

clean:
	rm -rf build acng-small acng-whole acng-static in.acng doc/.build

tarball: fixversion doc
#	if test "$(shell svn status | grep -v -i make)" ; then echo Uncommited files found. Run \"svn status\" to display them. ; exit 1 ; fi
	@if test -f ../$(DISTNAME).tar.gz ; then echo ../$(DISTNAME).tar.gz exists, not overwritting ; exit 1; fi
	-svn up
	rm -rf tmp
	mkdir tmp
	svn export . tmp/$(DISTNAME)
	cp -l tmp/$(DISTNAME)/doc/README tmp/$(DISTNAME)
	rm -rf tmp/$(DISTNAME)/debian tmp/$(DISTNAME)/tmp tmp/$(DISTNAME)/orig tmp/$(DISTNAME)/trash tmp/$(DISTNAME)/contrib
	tar -f - -c -C tmp $(DISTNAME) | gzip -9 > ../$(DISTNAME).tar.gz
	rm -rf tmp
	test -e /etc/debian_version && ln -f ../$(DISTNAME).tar.gz ../$(DEBSRCNAME) || true
	test -e ../tarballs && ln -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) || true

tarball-remove:
	rm -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) ../$(DEBSRCNAME) ../build-area/$(DEBSRCNAME)

SVNBASE=$(shell svn info | grep URL: | cut -f2 -d' ' | xargs dirname)
release: tarball
	svn ci
	svn cp $(SVNBASE)/trunk $(SVNBASE)/tags/release_$(shell cat VERSION)

#%::
#	$(MAKE) $(MAKE_FLAGS) build/Makefile
#	$(CMAKETWEAKS)
#	$(MAKE) -C build $(MAKE_FLAGS) $@

# needs to be explicite, for PHONY and install (AKA INSTALL) file on cygwin
#install: build/Makefile
#	$(CMAKETWEAKS)
#	$(MAKE) -C build $(MAKE_FLAGS) $@

acng: build/Makefile
	$(CMAKETWEAKS)
	$(MAKE) -C build $(MAKE_FLAGS) all

.PHONY: install all

# FIXME, forcing purge of cmakecache for now, it caches too much
.PHONY: build/Makefile

.PHONY: doc

## apt-cacher-ng 0.2.1

=== Makefile ===

hints:
	@echo To build apt-cacher-ng and/or helper programs, use:
	@echo 'make acng        (create apt-cacher-ng binary with some method)'
	@echo 'make acng-whole  (simple GCC based build, dynamic linking, optimized)'
	@echo 'make acng-debug  (simple GCC based build, with debug logging)'
	@echo 'make acng-static (simple GCC based build, static linking)'
	@echo 'make in.acng     (wrapper client for use with inetd)'
	@echo 'make acngfs      (http file system, needs FUSE library)'

acng: acng-whole acng-debug
	cp build/acng-whole apt-cacher-ng
	cp build/acng-debug apt-cacher-ng.debug

SRCS = $(wildcard source/*.cc) 3rd-party/md5.cc
embedded: acng-small
acng-small: $(SRCS)
	$(CXX) -o $@ -combine -Os -fno-exceptions $(SRCS) $(CXXFLAGS) -I include -lpthread -lz -lbz2
	strip $@

embstatic: acng-static
acng-static: $(SRCS)
	$(CXX) -o $@ -combine -Os -fno-exceptions $(CXXFLAGS) $(SRCS) -I include -static $(LDFLAGS) -lpthread -lz -lbz2

acng-whole: build/acng-whole
	
build/acng-whole: $(SRCS)
	mkdir -p build
	# for some reason -combine doesn't work well with -fwhole-program, trying a workaround...
	cat $(SRCS) > build/all.cc
	$(CXX) -o $@ -fwhole-program -g -O2 $(CXXFLAGS) build/all.cc -Iinclude -I3rd-party -lpthread $(LDFLAGS) -lz -lbz2
	@-test -d ../unstripped && cp build/acng-whole ../unstripped/apt-cacher-ng.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d:) || true
	strip $@

acng-debug: build/acng-debug
	
build/acng-debug: $(SRCS)
	mkdir -p build
	# for some reason -combine doesn't work well with -fwhole-program, trying a workaround...
	cat $(SRCS) > build/all.cc
	$(CXX) -o $@ -fwhole-program -g -O2 $(CXXFLAGS) -DDEBUG build/all.cc -Iinclude -I3rd-party -lpthread $(LDFLAGS) -lz -lbz2

lite: $(SRCS)
	$(CXX) -o $@ -combine -Os -fno-exceptions $(CXXFLAGS) $(SRCS) -I include $(LDFLAGS) -lpthread

in.acng: source/acbuf.cc client/client.cc
	mkdir -p build/cl
	$(CXX) $(CXXFLAGS) -O2 -c -o build/cl/client.o client/client.cc -Iinclude
	$(CXX) -O2 -c -o build/cl/acbuf.o source/acbuf.cc -Iinclude
	$(CC) -o $@ build/cl/client.o build/cl/acbuf.o -lsupc++ -Wl,--as-needed
	strip $@

SRCSMOUNT=source/dlcon.cc source/header.cc fs/src/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc source/rechecks.cc source/caddrinfo.cc
acngfs: build/acngfs
build/acngfs: $(SRCSMOUNT)
	mkdir -p build/fs
	$(CXX) -Iinclude -o acngfs `pkg-config fuse --cflags` $(SRCSMOUNT)  -Wl,--as-needed `pkg-config fuse --libs`

doc: doc/src/README.but doc/src/manpage.but doc/src/acngfs.but
	mkdir -p doc/.build doc/html doc/man
	cd doc/.build && halibut --text=README.txt --html --pdf ../src/README.but
	mv doc/.build/*.pdf doc
	mv doc/.build/README.txt doc/README
	mv doc/.build/*.html doc/html
	cd doc/.build && halibut --man ../src/manpage.but && halibut --man ../src/acngfs.but
	mv doc/.build/*.8 doc/man

fixversion: VERSION
	mkdir -p build/tmp
	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/acfg.h > build/tmp/hh
	cmp include/acfg.h build/tmp/hh || cp build/tmp/hh include/acfg.h

VERSION=$(shell cat VERSION)
DISTNAME=apt-cacher-ng-$(VERSION)
DEBSRCNAME=apt-cacher-ng_$(shell echo $(VERSION) | sed -e "s,pre,~pre,").orig.tar.gz

clean:
	rm -rf build apt-cacher-ng apt-cacher-ng.debug in.acng acngfs

tarball: fixversion doc
#	if test "$(shell svn status | grep -v -i make)" ; then echo Uncommited files found. Run \"svn status\" to display them. ; exit 1 ; fi
	@if test -f ../$(DISTNAME).tar.gz ; then echo ../$(DISTNAME).tar.gz exists, not overwritting ; exit 1; fi
	-svn up
	rm -rf tmp
	mkdir tmp
	svn export . tmp/$(DISTNAME)
	cp -l tmp/$(DISTNAME)/doc/README tmp/$(DISTNAME)
	rm -rf tmp/$(DISTNAME)/debian tmp/$(DISTNAME)/tmp tmp/$(DISTNAME)/orig tmp/$(DISTNAME)/trash tmp/$(DISTNAME)/contrib
	tar -f - -c -C tmp $(DISTNAME) | gzip -9 > ../$(DISTNAME).tar.gz
	rm -rf tmp
	test -e /etc/debian_version && ln -f ../$(DISTNAME).tar.gz ../$(DEBSRCNAME) || true
	test -e ../tarballs && ln -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) || true

tarball-remove:
	rm -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) ../$(DEBSRCNAME) ../build-area/$(DEBSRCNAME)

SVNBASE=$(shell svn info | grep URL: | cut -f2 -d' ' | xargs dirname)
release: tarball
	svn ci
	svn cp $(SVNBASE)/trunk $(SVNBASE)/tags/release_$(shell cat VERSION)

.PHONY: install all doc

## apt-cacher-ng 0.2.2

=== Makefile ===

hints:
	@echo To build apt-cacher-ng and/or helper programs, use:
	@echo 
	@echo 'make acng        (create apt-cacher-ng binary with some method)'
	@echo 'make in.acng     (wrapper client for use with inetd)'
	@echo 'make acngfs      (http file system, needs FUSE library)'
	@echo 'make all         (all of the above)'
	@echo
	@echo 'Parameters: DEBUG=1 -> creates a debug build'
	@echo
	@echo 'make clean       (deletes object, to do before changing parameters'
	@echo 


all: acng in.acng acngfs

stampbuild-checkenv: checkenv.sh
	@sh checkenv.sh $(CXX)
	@touch config.mk
	@touch $@

config.mk: stampbuild-checkenv

CXXFLAGS ?= -g -Os
CXXFLAGS += "-I$(CURDIR)/include"
-include config.mk

SRCS = $(wildcard source/*.cc) 3rd-party/md5.cc
SRCSFS = source/dlcon.cc source/header.cc fs/src/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc source/rechecks.cc source/caddrinfo.cc
SRCSIN = source/acbuf.cc client/client.cc
SRCSALL = $(SRCS) $(wildcard client/*.cc) $(wildcard fs/src/*.cc)

OBJS =  $(patsubst 3rd-party/%.cc,%.o, $(patsubst source/%.cc,%.o,$(SRCS)) )
OBJSFS =  $(patsubst fs/src/%.cc,%.o, $(patsubst source/%.cc,%.o,$(SRCSFS)) )
OBJSIN =  acbuf.o client.o

distclean: clean
	rm -rf checkenv.cc checkenv.o config.mk stampbuild-*

clean:
	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN)

acng: apt-cacher-ng

ifeq ($(DEBUG),)

# small build, even replacing libstdc++ with supc++ and gcc linking
in.acng: $(OBJSIN)
	$(CC) -o $@ $(OBJSIN) -lsupc++ -Wl,--as-needed
	strip $@

apt-cacher-ng: $(OBJS)
	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
	@-test -d ../unstripped && cp apt-cacher-ng ../unstripped/apt-cacher-ng.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
	strip apt-cacher-ng

else

CXXFLAGS += -DDEBUG -Wall

in.acng: $(OBJSIN) $(OBJS)
	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o aclogger.o -lz -lbz2 -Wl,--as-needed
	strip $@

apt-cacher-ng: $(OBJS)
	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
endif

acngfs: $(OBJSFS)
	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed `pkg-config fuse --libs`

doc: doc/src/README.but doc/src/manpage.but doc/src/acngfs.but
	mkdir -p doc/.build doc/html doc/man
	cd doc/.build && halibut --text=README.txt --html --pdf ../src/README.but
	mv doc/.build/*.pdf doc
	mv doc/.build/README.txt doc/README
	mv doc/.build/*.html doc/html
	cd doc/.build && halibut --man ../src/manpage.but && halibut --man ../src/acngfs.but
	mv doc/.build/*.8 doc/man

fixversion: VERSION
	mkdir -p build/tmp
	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/acfg.h > build/tmp/hh
	cmp include/acfg.h build/tmp/hh || cp build/tmp/hh include/acfg.h

VERSION=$(shell cat VERSION)
DISTNAME=apt-cacher-ng-$(VERSION)
DEBSRCNAME=apt-cacher-ng_$(shell echo $(VERSION) | sed -e "s,pre,~pre,").orig.tar.gz

tarball: fixversion doc
#	if test "$(shell svn status | grep -v -i make)" ; then echo Uncommited files found. Run \"svn status\" to display them. ; exit 1 ; fi
	@if test -f ../$(DISTNAME).tar.gz ; then echo ../$(DISTNAME).tar.gz exists, not overwritting ; exit 1; fi
	-svn up
	rm -rf tmp
	mkdir tmp
	svn export . tmp/$(DISTNAME)
	cp -l tmp/$(DISTNAME)/doc/README tmp/$(DISTNAME)
	rm -rf tmp/$(DISTNAME)/debian tmp/$(DISTNAME)/tmp tmp/$(DISTNAME)/orig tmp/$(DISTNAME)/trash tmp/$(DISTNAME)/contrib
	tar -f - -c -C tmp $(DISTNAME) | gzip -9 > ../$(DISTNAME).tar.gz
	rm -rf tmp
	test -e /etc/debian_version && ln -f ../$(DISTNAME).tar.gz ../$(DEBSRCNAME) || true
	test -e ../tarballs && ln -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) || true

tarball-remove:
	rm -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) ../$(DEBSRCNAME) ../build-area/$(DEBSRCNAME)

SVNBASE=$(shell svn info | grep URL: | cut -f2 -d' ' | xargs dirname)
release: tarball
	svn ci
	svn cp $(SVNBASE)/trunk $(SVNBASE)/tags/release_$(shell cat VERSION)

#.PHONY: install all doc

# some gmake magic to create stubs of implicite rules with gcc-generated prerequisite lists

.depend: $(SRCSALL)
	$(CXX) -Iinclude -D_FILE_OFFSET_BITS=64 -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > $@ || rm $@

VPATH = .:source:fs/src:client:3rd-party:include
$(OBJS) client.o: %.o: %.cc
	@test -e config.mk || ( echo ; echo Configuration failed. Please solve the problems reported above. ; false)
	$(CXX) -c $(CXXFLAGS) $< -o $@
httpfs.o: fs/src/httpfs.cc
	@test -e config.mk || ( echo ; echo Configuration failed. Please solve the problems reported above. ; false)
	$(CXX) -c $(CXXFLAGS) `pkg-config fuse --cflags`  $< -o $@

-include .depend

## apt-cacher-ng 0.3.4

=== Makefile ===

hints:
	@echo To build apt-cacher-ng and/or helper programs, use:
	@echo 
	@echo 'make acng    (create apt-cacher-ng binary with some method)'
	@echo 'make in.acng (wrapper client for use with inetd)'
	@echo 'make acngfs  (http file system, needs FUSE library)'
	@echo 'make all     (all of the above)'
	@echo
	@echo 'Parameters: DEBUG=1 -> creates a debug build'
	@echo
	@echo 'make clean   (deletes config and temporary files; call after parameter changes)'
	@echo 


all: acng in.acng acngfs

CXXFLAGS ?= -g -Os -Wall
CXXFLAGS += "-I$(CURDIR)/include"

stampbuild-checkenv: checkenv.sh
	@sh checkenv.sh $(CXX) $(CXXFLAGS) > acsyscap.h
	@touch $@

SRCS = $(wildcard source/*.cc)
SRCSFS = source/header.cc fs/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc source/rechecks.cc source/caddrinfo.cc
SRCSIN = source/acbuf.cc client/client.cc
SRCSALL = $(SRCS) client/client.cc fs/httpfs.cc

OBJS =  $(patsubst source/%.cc,%.o,$(SRCS))
OBJSFS =  $(patsubst fs/%.cc,%.o, $(patsubst source/%.cc,%.o,$(SRCSFS)) )
OBJSIN =  acbuf.o client.o

distclean: clean

clean:
	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN)
	rm -rf checkenv.cc checkenv.o stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 

acng: apt-cacher-ng

ifeq ($(DEBUG),)

# small build, even replacing libstdc++ with supc++ and gcc linking
in.acng: $(OBJSIN)
	$(CC) -o $@ $(OBJSIN) -lsupc++ -Wl,--as-needed
	strip $@

apt-cacher-ng: $(OBJS)
	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
	strip $@

else

CXXFLAGS += -DDEBUG -Wall

in.acng: $(OBJSIN) $(OBJS)
	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o sha1.o aclogger.o -lz -lbz2 -Wl,--as-needed
	strip $@

apt-cacher-ng: $(OBJS)
	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
endif

acngfs: $(OBJSFS)
	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed `pkg-config fuse --libs`
	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
	strip $@

doc: doc/src/README.but doc/src/manpage.but doc/src/acngfs.but
	mkdir -p doc/.build doc/html doc/man
	cd doc/.build && halibut --text=README.txt --html --pdf ../src/README.but
	mv doc/.build/*.pdf doc
	mv doc/.build/README.txt doc/README
	mv doc/.build/*.html doc/html
	cd doc/.build && halibut --man ../src/manpage.but && halibut --man ../src/acngfs.but
	mv doc/.build/*.8 doc/man

fixversion: VERSION
	mkdir -p build/tmp
	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/acfg.h > build/tmp/hh
	cmp include/acfg.h build/tmp/hh || cp build/tmp/hh include/acfg.h

VERSION=$(shell cat VERSION)
DISTNAME=apt-cacher-ng-$(VERSION)
DEBSRCNAME=apt-cacher-ng_$(shell echo $(VERSION) | sed -e "s,pre,~pre,").orig.tar.gz

tarball: fixversion doc depend
#	if test "$(shell svn status | grep -v -i make)" ; then echo Uncommited files found. Run \"svn status\" to display them. ; exit 1 ; fi
	@if test -f ../$(DISTNAME).tar.gz ; then echo ../$(DISTNAME).tar.gz exists, not overwritting ; exit 1; fi
	-svn up
	rm -rf tmp
	mkdir tmp
	svn export . tmp/$(DISTNAME)
	cp -l tmp/$(DISTNAME)/doc/README tmp/$(DISTNAME)
	rm -rf tmp/$(DISTNAME)/debian tmp/$(DISTNAME)/tmp tmp/$(DISTNAME)/orig tmp/$(DISTNAME)/trash tmp/$(DISTNAME)/contrib
	tar -f - -c -C tmp $(DISTNAME) | gzip -9 > ../$(DISTNAME).tar.gz
	rm -rf tmp
	test -e /etc/debian_version && ln -f ../$(DISTNAME).tar.gz ../$(DEBSRCNAME) || true
	test -e ../tarballs && ln -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) || true

tarball-remove:
	rm -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) ../$(DEBSRCNAME) ../build-area/$(DEBSRCNAME)

SVNBASE=$(shell svn info | grep URL: | cut -f2 -d' ' | xargs dirname)
release: tarball
	svn ci
	svn cp $(SVNBASE)/trunk $(SVNBASE)/tags/release_$(shell cat VERSION)

#.PHONY: install all doc

# some gmake magic to create stubs of implicite rules with gcc-generated prerequisite lists

VPATH = .:source:fs:client:3rd-party:include
$(OBJS) client.o: %.o: %.cc stampbuild-checkenv
	$(CXX) -c $(CXXFLAGS) $< -o $@
httpfs.o: fs/httpfs.cc stampbuild-checkenv
	$(CXX) -c $(CXXFLAGS) `pkg-config fuse --cflags`  $< -o $@

# not calling it .depend, shouldn't be triggered on user's PC
depend: $(SRCSALL) Makefile stampbuild-checkenv
	$(CXX) -Iinclude -D_FILE_OFFSET_BITS=64 -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend

-include .depend

## apt-cacher-ng 0.4.6

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+
 
 hints:
 	@echo To build apt-cacher-ng and/or helper programs, use:
@@ -10,12 +11,13 @@
 	@echo 'Parameters: DEBUG=1 -> creates a debug build'
 	@echo
 	@echo 'make clean   (deletes config and temporary files; call after parameter changes)'
+	@echo 'make gendbs  (fetches mirror data from the web, updates databases)'
 	@echo 
 
 
 all: acng in.acng acngfs
 
-CXXFLAGS ?= -g -Os -Wall
+CXXFLAGS ?= -g -Os -Wall -D_FILE_OFFSET_BITS=64
 CXXFLAGS += "-I$(CURDIR)/include"
 
 stampbuild-checkenv: checkenv.sh
@@ -31,10 +33,12 @@
 OBJSFS =  $(patsubst fs/%.cc,%.o, $(patsubst source/%.cc,%.o,$(SRCSFS)) )
 OBJSIN =  acbuf.o client.o
 
+DBTMP=dbgen/tmp
+
 distclean: clean
 
 clean:
-	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN)
+	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN) $(DBTMP)
 	rm -rf checkenv.cc checkenv.o stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
 
 acng: apt-cacher-ng
@@ -120,6 +124,26 @@
 
 # not calling it .depend, shouldn't be triggered on user's PC
 depend: $(SRCSALL) Makefile stampbuild-checkenv
-	$(CXX) -Iinclude -D_FILE_OFFSET_BITS=64 -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
+	$(CXX) -Iinclude -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
+
+gendbs:
+	mkdir -p $(DBTMP)
+	( w3m -dump http://www.iana.org/domains/root/db | perl -pe 'if(/^\.(\w\w)\s/) { $$_="http://".lc($$1).".archive.ubuntu.com/ubuntu\n";} else {undef $$_}';  wget -q -O- 'https://wiki.ubuntu.com/Mirrors?action=show&redirect=Archive' 'https://launchpad.net/ubuntu/+archivemirrors' ) | tr -d ' ' | tr -d '\t' | sed -e 's,",\n,g' | grep ^http | sort -u > $(DBTMP)/usnap
+	wget -q -O $(DBTMP)/dsnap 'http://cvs.debian.org/*checkout*/webwml/english/mirror/Mirrors.masterlist?rev=HEAD&cvsroot=webwml&content-type=text/plain'
+	md5sum $(DBTMP)/usnap > $(DBTMP)/sig-ubuntu
+	md5sum $(DBTMP)/dsnap > $(DBTMP)/sig-debian
+	cmp dbgen/sig-ubuntu $(DBTMP)/sig-ubuntu 2>/dev/null || cp $(DBTMP)/sig-ubuntu dbgen/sig-ubuntu 
+	cmp dbgen/sig-debian $(DBTMP)/sig-debian 2>/dev/null || cp $(DBTMP)/sig-debian dbgen/sig-debian
+	$(MAKE) $(MAKE_FLAGS) _dbconvert
+
+_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors
+
+conf/ubuntu_mirrors: dbgen/sig-ubuntu dbgen/ubuntuscan.sh
+	bash dbgen/ubuntuscan.sh $@ $(DBTMP)/usnap $(DBTMP)
+
+conf/debvol_mirrors.gz conf/deb_mirrors.gz: dbgen/sig-debian dbgen/debsplit.pl
+	perl dbgen/debsplit.pl < $(DBTMP)/dsnap
+	gzip -f -9 conf/deb_mirrors conf/debvol_mirrors
+
 
 -include .depend

=== debian/changelog ===
apt-cacher-ng (0.4.6-1ubuntu1) lucid-proposed; urgency=low

  * convert package to 3.0 (quilt) format
  * update-manager -d requires access to the DevelReleaseAnnouncement
    accessing it with a ?lang=foo suffix.  Add this to the persistant
    files list.  LP: #601883.

 -- Andy Whitcroft <apw@canonical.com>  Mon, 05 Jul 2010 14:09:48 +0100

apt-cacher-ng (0.4.6-1) unstable; urgency=medium

  * New upstream version
    + decodes some special chars for local storage (closes: #573222),
      affected users should refer to README.Debian for instructions about
      correction of the bad filenames

 -- Eduard Bloch <blade@debian.org>  Wed, 10 Mar 2010 22:12:57 +0100

apt-cacher-ng (0.4.5-1) unstable; urgency=low

  * New upstream release
    + documented DnsCacheSeconds (Ubuntu bug 530524)
    + Added simple implementation of SOAP request forwarding for PTS 
      access (closes: #453277)
    + Typo fix in userinfo.html (closes: #572171)

 -- Eduard Bloch <blade@debian.org>  Wed, 03 Mar 2010 21:31:40 +0100

apt-cacher-ng (0.4.4-1) unstable; urgency=low

  * New upstream release
    + adds a more meaningful message for incorrect backend mirror
      settings (closes: #549222)
    + internal improvements, still hunting bug #558133
  * init script and policy compliancy updates

 -- Eduard Bloch <blade@debian.org>  Sun, 21 Feb 2010 23:04:58 +0100

apt-cacher-ng (0.4.3-1) unstable; urgency=medium

  * Support for new dpkg v3 source formats

 -- Eduard Bloch <blade@debian.org>  Sun, 06 Dec 2009 12:22:36 +0100

apt-cacher-ng (0.4.2-1) unstable; urgency=medium

  * New upstream release
    + little documentation fixes, corrected format of the import howto and
      explained the results of the procedure (closes: #559075)
  * Fix repeated setup on package upgrade (closes: #559024). Also tries to
    keep backend config files if the user maintained them manually before but
    they could not generated at all via automated setup.

 -- Eduard Bloch <blade@debian.org>  Tue, 01 Dec 2009 21:52:29 +0100

apt-cacher-ng (0.4.1-1) unstable; urgency=low

  [ Jonathan Wiltshire <debian@jwiltshire.org.uk> ]
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #552017
  * Debconf translation updates:
    - Russian (closes: #545211)
    - Finnish (closes: #552253)
    - Czech (closes: #552452)
    - Basque (closes: #552806)
    - Japanese (closes: #553029)
    - Portugese (closes: #554119)
    - Swedish (closes: #554137)
    - French (closes: #554366)
    - Galician (closes: #554634)

  [ Eduard Bloch ]
  * debconf update, reduced query to one dialog
  * Debconf translation updates from contributors:
    - Italian (closes: #556109)
    - Spanish (closes: #538106)
  * New upstream release:
    + enabled resuming of downloads of incomplete files where the conditions
      allow that without nasty side effects (closes: #544205)
    + passing HTTP redirection target through to user (closes: #556234)
  * Unconfuse crontab expiration script when BindAdress contains multiple
    entries (patch by Hellekin O\. Wolf, closes: #554707)
 
 -- Eduard Bloch <blade@debian.org>  Sun, 22 Nov 2009 19:06:32 +0100

apt-cacher-ng (0.4-1) unstable; urgency=low

  * New upstream release
    + Fixes thread leak due to race condition, based on patch
      from Alexander Inyukhin (thanks, closes: #530440)

 -- Eduard Bloch <blade@debian.org>  Tue, 26 May 2009 00:03:20 +0200

apt-cacher-ng (0.3.12-1) unstable; urgency=low

  * New upstream release
    + more reliable closing of file handles (might solve #529744)
    + reveals origin of 40x HTTP errors to the user (for #530021)
  * verbose Debconf configuration for automated backend setup which repeatedly
    confused some users in the past (closes: #530021). Deprecates the
    truncate-and-reconfigure trick.

 -- Eduard Bloch <blade@debian.org>  Mon, 25 May 2009 01:21:29 +0200

apt-cacher-ng (0.3.11-1) unstable; urgency=low

  * New upstream release
  * Log file removal on purge (closes: #527378)

 -- Eduard Bloch <blade@debian.org>  Sat, 09 May 2009 19:50:34 +0200

apt-cacher-ng (0.3.10-1) unstable; urgency=high

  * New upstream release
    + fixing a subtle change in 0.3.9 which breaks import function and might
    cause cache damage for users who manually run expiration with data
    checksumming (many thanks to Petra Ruebe-Pugliese, closes: #526956)

 -- Eduard Bloch <blade@debian.org>  Mon, 04 May 2009 23:02:41 +0200

apt-cacher-ng (0.3.9-1) unstable; urgency=medium

  * New upstream release
  * Moved service disabling check to the correct place (closes: #523290)

 -- Eduard Bloch <blade@debian.org>  Tue, 21 Apr 2009 23:55:16 +0200

apt-cacher-ng (0.3.8-1) unstable; urgency=medium

  * New upstream release
  * Fixed init script deactivation (closes: #522186)

 -- Eduard Bloch <blade@debian.org>  Sat, 04 Apr 2009 23:03:52 +0200

apt-cacher-ng (0.3.7-1) unstable; urgency=medium

  * New upstream release
    + fixes debian-volatile confusion, updated the mirror list (closes: #522239)
    + added some documentation and a documentation reference to the error
      messages for the busy port condition (closes: #522178)
  * mirror picker improvements: considering ftp sources correctly, removing
    duplicate lines in backend files
  * added support for the init script deactivation with an environment
    variable (closes: #522186)

 -- Eduard Bloch <blade@debian.org>  Fri, 03 Apr 2009 22:53:25 +0200

apt-cacher-ng (0.3.6-1) unstable; urgency=low

  * New upstream release with minor speedups
  * Fixed new bashisms in the init script (closes: #521465)

 -- Eduard Bloch <blade@debian.org>  Fri, 27 Mar 2009 22:26:18 +0100

apt-cacher-ng (0.3.5-2) unstable; urgency=low

  * Added ftp: as possible pattern when looking for good mirrors in
    sources.list for backend definition creation (now really closes: #520824)

 -- Eduard Bloch <blade@debian.org>  Thu, 26 Mar 2009 23:59:36 +0100



=== debian/control ===
Source: apt-cacher-ng
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 5), libbz2-dev, zlib1g-dev, libfuse-dev, pkg-config
Standards-Version: 3.8.4

Package: apt-cacher-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: perl (>> 5.8), ed
Description: caching proxy server for software repositories
 Apt-Cacher NG is a caching proxy for downloading packages from Debian-style
 software repositories (or possibly from other types).
 .
 The main principle is that a central machine hosts the proxy for a local
 network, and clients configure their APT setup to download through it.
 Apt-Cacher NG keeps a copy of all useful data that passes through it, and when
 a similar request is made, the cached copy of the data is delivered without
 being re-downloaded.
 .
 Apt-Cacher NG has been designed from scratch as a replacement for
 apt-cacher, but with a focus on maximizing throughput with low system
 resource requirements. It can also be used as replacement for apt-proxy and
 approx with no need to modify clients' sources.list files.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

SHELL=/bin/bash
CDIR=$(CURDIR)/debian/apt-cacher-ng/etc/apt-cacher-ng/

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

CXXFLAGS=$(CFLAGS)
export CXXFLAGS

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) all
	# may fail if halibut is not installed, doesn't matter
	-$(MAKE) doc
	#docbook-to-man debian/apt-cacher-ng.sgml > apt-cacher-ng.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) distclean || true

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/apt-cacher-ng.
	#$(MAKE) DESTDIR=$(CURDIR)/debian/apt-cacher-ng install
	install apt-cacher-ng $(CURDIR)/debian/apt-cacher-ng/usr/sbin/apt-cacher-ng
	#install acngfs $(CURDIR)/debian/apt-cacher-ng/usr/sbin/
	install acngfs in.acng expire-caller.pl urlencode-fixer.pl distkill.pl $(CURDIR)/debian/apt-cacher-ng/usr/lib/apt-cacher-ng/
	cp -a conf/{*mirror*,*.html,*.css} $(CURDIR)/debian/apt-cacher-ng/usr/lib/apt-cacher-ng
	cp -a conf/*.conf $(CDIR)
	> $(CDIR)/backends_debian
	> $(CDIR)/backends_debvol
	> $(CDIR)/backends_ubuntu
	cd $(CDIR) && cp -s ../../usr/lib/apt-cacher-ng/{*mirror*,*.html,*.css} .

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples conf/*.conf
#	dh_install
#	dh_installmenu
	dh_installdebconf	
	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
	dh_installinit
	dh_installcron
#	dh_installinfo
	dh_installman doc/man/*.8
	#dh_installman doc/man/apt-cacher-ng.8
	dh_link
	dh_strip
	dh_compress -X.pdf
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## apt-cacher-ng 0.5.1

=== Makefile ===
--- 
+++ 
@@ -17,21 +17,29 @@
 
 all: acng in.acng acngfs
 
-CXXFLAGS ?= -g -Os -Wall -D_FILE_OFFSET_BITS=64
-CXXFLAGS += "-I$(CURDIR)/include"
+# no presets from environment? Remember some optimization flags then...
+ifeq ($(CXXFLAGS),)
+__acng_opt_flags=-O2 -Wall
+endif
 
+# some useful or required flags
+CXXFLAGS += -D_FILE_OFFSET_BITS=64 "-I$(CURDIR)/include"
+
+configure: stampbuild-checkenv
 stampbuild-checkenv: checkenv.sh
 	@sh checkenv.sh $(CXX) $(CXXFLAGS) > acsyscap.h
 	@touch $@
 
+acsyscap.h: stampbuild-checkenv
+
 SRCS = $(wildcard source/*.cc)
-SRCSFS = source/header.cc fs/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc source/rechecks.cc source/caddrinfo.cc
+SRCSFS = source/header.cc fs/httpfs.cc source/lockable.cc source/meta.cc source/acbuf.cc source/caddrinfo.cc source/acfg_defaults.cc source/acfg.cc source/filereader.cc source/md5.cc source/sha1.cc
 SRCSIN = source/acbuf.cc client/client.cc
 SRCSALL = $(SRCS) client/client.cc fs/httpfs.cc
 
 OBJS =  $(patsubst source/%.cc,%.o,$(SRCS))
 OBJSFS =  $(patsubst fs/%.cc,%.o, $(patsubst source/%.cc,%.o,$(SRCSFS)) )
-OBJSIN =  acbuf.o client.o
+OBJSIN =  client.o
 
 DBTMP=dbgen/tmp
 
@@ -39,11 +47,13 @@
 
 clean:
 	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN) $(DBTMP)
-	rm -rf checkenv.cc checkenv.o stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
+	rm -rf checkenv.cc checkenv.o checkenv_testbin checkenv_testbin.exe stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
 
 acng: apt-cacher-ng
 
 ifeq ($(DEBUG),)
+
+CXXFLAGS += $(__acng_opt_flags)
 
 # small build, even replacing libstdc++ with supc++ and gcc linking
 in.acng: $(OBJSIN)
@@ -52,12 +62,11 @@
 
 apt-cacher-ng: $(OBJS)
 	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
-	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
-	strip $@
+	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 else
 
-CXXFLAGS += -DDEBUG -Wall
+CXXFLAGS += -DDEBUG -g -Wall -O0
 
 in.acng: $(OBJSIN) $(OBJS)
 	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o sha1.o aclogger.o -lz -lbz2 -Wl,--as-needed
@@ -67,10 +76,11 @@
 	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
 endif
 
+FUSECFLAGS=$(shell pkg-config --cflags fuse)
+FUSELFLAGS=$(shell pkg-config --libs fuse)
 acngfs: $(OBJSFS)
-	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed `pkg-config fuse --libs`
-	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
-	strip $@
+	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed $(FUSELFLAGS) -lz -lbz2
+	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 doc: doc/src/README.but doc/src/manpage.but doc/src/acngfs.but
 	mkdir -p doc/.build doc/html doc/man
@@ -83,8 +93,8 @@
 
 fixversion: VERSION
 	mkdir -p build/tmp
-	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/acfg.h > build/tmp/hh
-	cmp include/acfg.h build/tmp/hh || cp build/tmp/hh include/acfg.h
+	sed -e 's,^.*define.*ACVERSION.*,#define ACVERSION "$(VERSION)",' < include/config.h > build/tmp/hh
+	cmp include/config.h build/tmp/hh || cp build/tmp/hh include/config.h
 
 VERSION=$(shell cat VERSION)
 DISTNAME=apt-cacher-ng-$(VERSION)
@@ -120,30 +130,49 @@
 $(OBJS) client.o: %.o: %.cc stampbuild-checkenv
 	$(CXX) -c $(CXXFLAGS) $< -o $@
 httpfs.o: fs/httpfs.cc stampbuild-checkenv
-	$(CXX) -c $(CXXFLAGS) `pkg-config fuse --cflags`  $< -o $@
+	$(CXX) -c $(CXXFLAGS) $(FUSECFLAGS)  $< -o $@
 
 # not calling it .depend, shouldn't be triggered on user's PC
 depend: $(SRCSALL) Makefile stampbuild-checkenv
 	$(CXX) -Iinclude -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
 
-gendbs:
+gendbs: get_deb_input get_ubu_input get_cyg_input
+	$(MAKE) $(MAKE_FLAGS) _dbconvert
+
+get_deb_input:
+	mkdir -p $(DBTMP)
+	wget -q -O $(DBTMP)/dsnap 'http://cvs.debian.org/*checkout*/webwml/english/mirror/Mirrors.masterlist?rev=HEAD&cvsroot=webwml&content-type=text/plain'
+	md5sum $(DBTMP)/dsnap > $(DBTMP)/sig-debian
+	cmp dbgen/sig-debian $(DBTMP)/sig-debian 2>/dev/null || cp $(DBTMP)/sig-debian dbgen/sig-debian
+
+get_ubu_input:
 	mkdir -p $(DBTMP)
 	( w3m -dump http://www.iana.org/domains/root/db | perl -pe 'if(/^\.(\w\w)\s/) { $$_="http://".lc($$1).".archive.ubuntu.com/ubuntu\n";} else {undef $$_}';  wget -q -O- 'https://wiki.ubuntu.com/Mirrors?action=show&redirect=Archive' 'https://launchpad.net/ubuntu/+archivemirrors' ) | tr -d ' ' | tr -d '\t' | sed -e 's,",\n,g' | grep ^http | sort -u > $(DBTMP)/usnap
-	wget -q -O $(DBTMP)/dsnap 'http://cvs.debian.org/*checkout*/webwml/english/mirror/Mirrors.masterlist?rev=HEAD&cvsroot=webwml&content-type=text/plain'
 	md5sum $(DBTMP)/usnap > $(DBTMP)/sig-ubuntu
-	md5sum $(DBTMP)/dsnap > $(DBTMP)/sig-debian
 	cmp dbgen/sig-ubuntu $(DBTMP)/sig-ubuntu 2>/dev/null || cp $(DBTMP)/sig-ubuntu dbgen/sig-ubuntu 
-	cmp dbgen/sig-debian $(DBTMP)/sig-debian 2>/dev/null || cp $(DBTMP)/sig-debian dbgen/sig-debian
-	$(MAKE) $(MAKE_FLAGS) _dbconvert
 
-_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors
+get_cyg_input:
+	mkdir -p $(DBTMP)
+	wget -q -O- http://cygwin.com/mirrors.lst | grep ^http | cut -f1 -d\; >$(DBTMP)/mirrors.http
+	md5sum $(DBTMP)/mirrors.http > $(DBTMP)/sig-cygwin
+	cmp dbgen/sig-cygwin $(DBTMP)/sig-cygwin 2>/dev/null || cp $(DBTMP)/sig-cygwin dbgen/sig-cygwin
+
+_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors conf/cygwin_mirrors
 
 conf/ubuntu_mirrors: dbgen/sig-ubuntu dbgen/ubuntuscan.sh
 	bash dbgen/ubuntuscan.sh $@ $(DBTMP)/usnap $(DBTMP)
+
+conf/cygwin_mirrors: Makefile dbgen/sig-cygwin
+	cp $(DBTMP)/mirrors.http conf/cygwin_mirrors
 
 conf/debvol_mirrors.gz conf/deb_mirrors.gz: dbgen/sig-debian dbgen/debsplit.pl
 	perl dbgen/debsplit.pl < $(DBTMP)/dsnap
 	gzip -f -9 conf/deb_mirrors conf/debvol_mirrors
 
+# help the automatic dependency tracking
+acsyscap.h: stampbuild-checkenv
+include/../acsyscap.h: acsyscap.h
+client/../acsyscap.h: acsyscap.h
+fs/../acsyscap.h: acsyscap.h
 
 -include .depend

## apt-cacher-ng 0.5.6

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 clean:
 	rm -rf build apt-cacher-ng in.acng acngfs stamp-* $(OBJS) $(OBJSFS) $(OBJSIN) $(DBTMP)
-	rm -rf checkenv.cc checkenv.o checkenv_testbin checkenv_testbin.exe stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe 
+	rm -rf checkenv.cc checkenv.o checkenv_testbin checkenv_testbin.exe stampbuild-* acsyscap.h getlongsize getlongsize.exe testendian testendian.exe checksuf checksuf.exe link.flags
 
 acng: apt-cacher-ng
 
@@ -61,25 +61,26 @@
 	strip $@
 
 apt-cacher-ng: $(OBJS)
-	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
-	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
+	$(CXX) $(CXXFLAGS) -o $@ $(OBJS) -lpthread $(LDFLAGS) `cat link.flags`
+	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
+#@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 else
 
 CXXFLAGS += -DDEBUG -g -Wall -O0
 
 in.acng: $(OBJSIN) $(OBJS)
-	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o sha1.o aclogger.o -lz -lbz2 -Wl,--as-needed
+	$(CXX) -o $@ acbuf.o client.o acfg.o filereader.o meta.o md5.o sha1.o aclogger.o -Wl,--as-needed
 	strip $@
 
 apt-cacher-ng: $(OBJS)
-	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) -lz -lbz2
+	$(CXX) -o $@ $(OBJS) -lpthread $(LDFLAGS) `cat link.flags`
 endif
 
 FUSECFLAGS=$(shell pkg-config --cflags fuse)
 FUSELFLAGS=$(shell pkg-config --libs fuse)
 acngfs: $(OBJSFS)
-	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed $(FUSELFLAGS) -lz -lbz2
+	$(CXX) -o acngfs $(OBJSFS) -Wl,--as-needed $(FUSELFLAGS) `cat link.flags`
 	@-test -d ../unstripped && cp $@ ../unstripped/$@.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') && strip $@ || true
 
 doc: doc/src/README.but doc/src/manpage.but doc/src/acngfs.but
@@ -113,6 +114,7 @@
 	rm -rf tmp
 	test -e /etc/debian_version && ln -f ../$(DISTNAME).tar.gz ../$(DEBSRCNAME) || true
 	test -e ../tarballs && ln -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) || true
+	test -e ../build-area && ln -f ../$(DISTNAME).tar.gz ../build-area/$(DEBSRCNAME) || true
 
 tarball-remove:
 	rm -f ../$(DISTNAME).tar.gz ../tarballs/$(DEBSRCNAME) ../$(DEBSRCNAME) ../build-area/$(DEBSRCNAME)
@@ -121,6 +123,9 @@
 release: tarball
 	svn ci
 	svn cp $(SVNBASE)/trunk $(SVNBASE)/tags/release_$(shell cat VERSION)
+
+unrelease: tarball-remove
+	svn rm $(SVNBASE)/tags/release_$(shell cat VERSION)
 
 #.PHONY: install all doc
 
@@ -136,7 +141,8 @@
 depend: $(SRCSALL) Makefile stampbuild-checkenv
 	$(CXX) -Iinclude -MM $(SRCSALL) $(CXXFLAGS) $(CPPFLAGS) > .depend
 
-gendbs: get_deb_input get_ubu_input get_cyg_input
+# first get and check data, then replace the mirror output lists but for some sources do it only when needed 
+gendbs: get_deb_input get_ubu_input
 	$(MAKE) $(MAKE_FLAGS) _dbconvert
 
 get_deb_input:
@@ -151,23 +157,22 @@
 	md5sum $(DBTMP)/usnap > $(DBTMP)/sig-ubuntu
 	cmp dbgen/sig-ubuntu $(DBTMP)/sig-ubuntu 2>/dev/null || cp $(DBTMP)/sig-ubuntu dbgen/sig-ubuntu 
 
-get_cyg_input:
-	mkdir -p $(DBTMP)
-	wget -q -O- http://cygwin.com/mirrors.lst | grep ^http | cut -f1 -d\; >$(DBTMP)/mirrors.http
-	md5sum $(DBTMP)/mirrors.http > $(DBTMP)/sig-cygwin
-	cmp dbgen/sig-cygwin $(DBTMP)/sig-cygwin 2>/dev/null || cp $(DBTMP)/sig-cygwin dbgen/sig-cygwin
-
-_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors conf/cygwin_mirrors
+_dbconvert: conf/deb_mirrors.gz conf/debvol_mirrors.gz conf/ubuntu_mirrors conf/cygwin_mirrors conf/archlx_mirrors
 
 conf/ubuntu_mirrors: dbgen/sig-ubuntu dbgen/ubuntuscan.sh
 	bash dbgen/ubuntuscan.sh $@ $(DBTMP)/usnap $(DBTMP)
 
 conf/cygwin_mirrors: Makefile dbgen/sig-cygwin
-	cp $(DBTMP)/mirrors.http conf/cygwin_mirrors
+	wget -q -O- http://cygwin.com/mirrors.lst | grep ^http | cut -f1 -d\; > conf/cygwin_mirrors
+
+conf/archlx_mirrors: Makefile
+	wget -q --no-check-certificate  -O- 'https://archlinux.de/?page=MirrorStatus' | grep nofollow | cut -f2 -d'"'  | grep ^http > conf/archlx_mirrors
 
 conf/debvol_mirrors.gz conf/deb_mirrors.gz: dbgen/sig-debian dbgen/debsplit.pl
 	perl dbgen/debsplit.pl < $(DBTMP)/dsnap
 	gzip -f -9 conf/deb_mirrors conf/debvol_mirrors
+
+.PHONY: conf/archlx_mirrors conf/cygwin_mirrors
 
 # help the automatic dependency tracking
 acsyscap.h: stampbuild-checkenv
